from genericpath import exists
import os
import argparse
import shutil



parser = argparse.ArgumentParser()
parser.add_argument('--dir',)
args = parser.parse_args()
print(args)
for _, subdirs, _ in os.walk(args.dir):
    break

best_eval_res = -100
best_param = None
for subdir in subdirs:
    dir_name = os.path.join(args.dir, subdir)
    for _, _, files in os.walk(dir_name):
        break
    eval_results = -100
    for file in files:
        if file.startswith("eval_results"):
            f = open(os.path.join(dir_name, file))
            res = float(f.readlines()[1].strip().split(' = ')[1])
            print(res)
            break
    if res > best_eval_res:
        best_eval_res = res
        best_param = subdir

save_dir = os.path.join(args.dir, "best")
os.makedirs(save_dir, exist_ok=True)
f = open(os.path.join(save_dir, "best_param.txt"), 'w')
f.write(best_param + '\n' + str(best_eval_res))
shutil.copyfile(os.path.join(args.dir, best_param, "pytorch_model.bin"), os.path.join(save_dir, "pytorch_model.bin"))
shutil.copyfile(os.path.join(args.dir, best_param, "config.json"), os.path.join(save_dir, "config.json"))

# print(best_eval_res)
# print(best_param)

for subdir in subdirs:
    dir_name = os.path.join(args.dir, subdir)
    if 'best' not in subdir and os.path.exists(os.path.join(dir_name, "pytorch_model.bin")):
        os.remove(os.path.join(dir_name, "pytorch_model.bin"))
